<?php 
/*
	Plugin Name: NtzAntispam
	Description: <a href="options-general.php?page=ntz_antispam_settings">Make sure you fill the password field!</a>
	Version: 2.0e
	Author: Ionut Staicu
	Author URI: http://www.iamntz.com
*/
function ntz_antispam($content){
	$moveInTrash = true; 
	$currentTime = time();
	$howManySeconds = 5;
	$nonce = get_option('ntzAntispamNonce');
	if(is_user_logged_in()) {
		global $current_user;
	  get_currentuserinfo();
		if($current_user->wp_user_level == 10 || $current_user->user_level == 10) {
			return $content;
		}
	}
	

	if( (!isset($_POST['comment_time']) || $currentTime - $_POST['comment_time'] < $howManySeconds ) || (!isset($_POST['comment_nonce']) || $_POST['comment_nonce'] != md5($nonce)) ) {
		die("Nope...");
		
		function moveInSpam($comment_ID){
			wp_set_comment_status($comment_ID, 'spam');
		}
		add_action('comment_post', 'moveInSpam');
	}	
	return $content;
}
function ntz_antispam_check($content){
	$nonce = get_option('ntzAntispamNonce');
	echo '<input type="hidden" name="comment_time" id="comment_time" value="'.time().'" />';
	echo '<input type="hidden" name="comment_nonce" id="comment_nonce" value="'.md5($nonce).'" />';
}
add_action('comment_form', 'ntz_antispam_check');
add_action('add_meta_boxes_comment', 'ntz_antispam_check');
add_filter('pre_comment_content', 'ntz_antispam');


add_action('admin_menu', 'ntz_antispam_settings_init');
function ntz_antispam_settings_init(){
	add_options_page('ntzAntispam', 'ntzAntispam', 'administrator', 'ntz_antispam_settings', 'ntz_antispam_settings');
}
function ntz_antispam_settings(){
	if($_POST['ntz_do']=='save'){
    update_option( 'ntzAntispamNonce', htmlentities($_POST['ntzAntispamNonce'], ENT_QUOTES) );
		}

	$ntzAntispamNonce = get_option('ntzAntispamNonce');
	if(strlen($ntzAntispamNonce)<2){
		$ntzAntispamNonce = SECURE_AUTH_KEY;
	}
	echo '<form class="wrap ntz_custom_form" method="post" action=""><h2>ntzAntispam2 settings</h2> <input type="hidden" name="ntz_do" value="save" />';
	
	
	echo '<p><label>ntzAntispam2 password:</label>';
		echo '<input type="text" name="ntzAntispamNonce" value="'.$ntzAntispamNonce.'" id="ntzAntispamNonce" style="width:500px" />';
	echo '</p>';
	echo '<p>Please make sure you filled `Authentication Unique Keys and Salts` in your wp-config file or use a unique-very-long-string as a password!</p>';
	
	
	echo '<p><input type="submit" value="Save Settings" class="button-primary" name="submit"></p>';
	echo '</form>';
}